'use strict'

let express = require('express')
let app = express()
let cors = require('cors')
let compression = require('compression')
let bodyParser = require('body-parser')
let Errors = require('app/errors')
let api = require('./api')
let db = require('app/db')

db.once('open', console.log.bind(console, 'web connected to mongo'))

app.use(cors())
app.use(compression())
app.use(bodyParser.json())

app.use('/api', api)

// Set responses based on error types
app.use(Errors.ErrorMiddleware)

module.exports = app
