import {Component, View} from 'angular2/core'
import {NgIf} from 'angular2/common'

import Service from './service'

@Component({
  selector: 'alert-box',
  providers: [Service]
})
@View({
  directives: [NgIf],
  template: `
<div *ngIf="showAlert" class="alert alert-warning alert-dismissible fade in" role="alert">
  <button type="button" class="close" (click)="close()" data-dismiss="alert" aria-label="Close">
    <span aria-hidden="true">&times;</span>
  </button>
  <strong>{{title}}</strong> {{desc}}
</div>
`
})
export default class AlertBox {
  constructor (service: Service) {
    this.title = ''
    this.desc = ''
    this.showAlert = false
    service
      .getOb()
      .subscribe(res => {
        this.title = res.title || ''
        this.desc = res.desc || ''
        this.showAlert = true
      })
  }
  close () {
    this.showAlert = false
  }
}
