import { Component, View } from 'angular2/core'
import { NgFor } from 'angular2/common'
import { ROUTER_DIRECTIVES } from 'angular2/router'
import ShipService from './service'


@Component({
  selector: 'ship-list',
  providers: [ShipService]
})
@View({
  directives: [ROUTER_DIRECTIVES, NgFor],
  template: `
  <h1 class="title">Ships <a class="btn btn-primary" [routerLink]="['/ShipNew']" title="Create a new Ship">New</a></h1>
  <ul class="master-list">
    <li *ngFor="#ship of ships"><a [routerLink]="['/ShipView', {id: ship._id}]">{{ ship.title }}</a></li>
  </ul>
`
})
export default class ShipList {
  constructor (service: ShipService) {
    service
      .getShips()
      .subscribe(res => this.ships = res)
  }
}
