import { Component, View } from 'angular2/core'
import { NgFor } from 'angular2/common'
import { ROUTER_DIRECTIVES } from 'angular2/router'
import WeaponService from './service'


@Component({
  selector: 'weapon-list',
  providers: [WeaponService]
})
@View({
  directives: [ROUTER_DIRECTIVES, NgFor],
  template: `
  <h1 class="title">Weapons <a class="btn btn-primary" [routerLink]="['/WeaponNew']" title="Create a new Weapon">New</a></h1>
  <ul class="master-list">
    <li *ngFor="#weapon of weapons"><a [routerLink]="['/WeaponView', {id: weapon._id}]">{{ weapon.title }}</a></li>
  </ul>
`
})
export default class WeaponList {
  constructor (service: WeaponService) {
    service
      .getWeapons()
      .subscribe(res => this.weapons = res)
  }
}
