import { Component, View } from 'angular2/core'
import {NgClass} from 'angular2/common'
import {ROUTER_DIRECTIVES, RouteParams, Router} from 'angular2/router'
import WeaponService from './service'

@Component({
  selector: 'weapon-view',
  providers: [WeaponService]
})
@View({
  directives: [ROUTER_DIRECTIVES, NgClass],
  template: `
  <h1>{{weapon.title}}
  <button type="button" (click)="handleClick($event)" class="btn btn-primary"><i class="fa fa-edit fa-lg"></i></button>
  </h1>
  <p>{{weapon.description}}</p>
`
})
export default class WeaponView {
  constructor (params: RouteParams, router: Router, service: WeaponService) {
    this.id = params.get('id')
    this.router = router
    this.weapon = {}
    this.service = service
    this.hyperIcon = 'fa-remove'
    service
      .getWeapon(this.id)
      .subscribe(
        res => this.weapon = res,
        err => {
          console.error(err)
          if (err.status === 401) this.router.navigate(['/Login'])
        }
      )
  }

  handleClick ($event) {
    this.router.navigate(['/WeaponEdit', {id: this.id}])
  }
}
