import _ from 'lodash'

export const VALIDATORS = {
  title: function (data) {
    return !_.isEmpty(data)
  }
}

export class Weapon {
  constructor (_data) {
    let data = _data || {}

    _.assign(this, data)
  }
  isValid (data) {
    let validators = this.validators()
    return _.every(data, (val, key) => {
      let fn = validators[key]
      return _.isFunction(fn) ? fn.call(this, val) : true
    })
  }
  toJSON () {
    return _.pick(this, ['_id', 'title', 'description'])
  }
  validators () {
    return VALIDATORS
  }
}
