import {Attribute, Component, View} from 'angular2/core'
import {NgIf} from 'angular2/common'

@Component({
  selector: 'save-button',
  inputs: ['disableSave', 'isSaving']
})
@View({
  directives: [NgIf],
  template: `
  <button type="submit" class="btn btn-primary" [disabled]="disableSave || isSaving">
    <i *ngIf="isSaving" class="fa fa-refresh fa-spin"></i>
    <i *ngIf="!isSaving" class="fa fa-floppy-o"></i>
    {{name}}
  </button>
`
})
export default class MasterEdit {
  constructor (@Attribute('name') name) {
    this.name = name || 'Save'
  }
}
