import './style.scss'

import {Component, View, FORM_DIRECTIVES, FormBuilder} from 'angular2/angular2'

@Component({
  selector: 'master-form'
})
@View({
  directives: [FORM_DIRECTIVES],
  template: `
  <form (ng-submit)="onSubmit()" [ng-form-model]="form" #f="form">
    <div>
        <div class="formHeading">First Name</div>
        <input type="text" id="firstName" ng-control="firstName">
        <div class="errorMessage" *ng-if="f.form.controls.firstName.touched && !f.form.controls.firstName.valid">First Name is required</div>
    </div>
    <div>
        <div class="formHeading">Street Address</div>
        <input type="text" id="firstName" ng-control="streetAddress">
        <div class="errorMessage" *ng-if="f.form.controls.streetAddress.touched && !f.form.controls.streetAddress.valid">Street Address is required</div>
    </div>
    <div>
        <div class="formHeading">Zip Code</div>
        <input type="text" id="zip" ng-control="zip">
        <div class="errorMessage" *ng-if="f.form.controls.zip.touched && !f.form.controls.zip.valid">Zip code has to be 5 digits long</div>
    </div>
    <div>
        <div class="formHeading">Address Type</div>
        <select id="type" ng-control="type">
            <option [value]="'home'">Home Address</option>
            <option [value]="'billing'">Billing Address</option>
        </select>
    </div>
    <button type="submit" [disabled]="!f.form.valid">Save</button>
    <div>
        <div>The form contains the following values</div>
        <div>
            {{payLoad}}
        </div>
    </div>
  </form>
`
})
export default class NavBar {
  constructor(fb: FormBuilder) {
    this.form = fb.group({
      "firstName": [],
      "lastName": []
    })
  }

}
