import _ from 'lodash'

function firstNameValidator (data) {
  return !_.isEmpty(data)
}

function emailValidator (data) {
  return _.isEmpty(data) ? true : /^.*@.+\..+$/.test(data)
}

export const VALIDATORS = {
  firstName: firstNameValidator,
  email: emailValidator
}

export class Master {
  constructor (_data) {
    let data = _data || {}

    _.assign(this, data)
  }
  get fullname () {
    return `${this.firstName || ''} ${this.lastName || ''}`
  }
  isValid (data) {
    let validators = this.validators()
    return _.every(data, (val, key) => {
      let fn = validators[key]
      return _.isFunction(fn) ? fn.call(this, val) : true
    })
  }
  toJSON () {
    return _.pick(this, ['_id', 'firstName', 'lastName'])
  }
  validators () {
    return VALIDATORS
  }
}
