import {Http} from 'angular2/http'
import {Injectable} from 'angular2/core'
import 'rxjs/add/operator/map'
import config from '../config'
import {Ship} from './ship'
import TokenService from '../users/token'

function convertToShip (data) {
  return new Ship(data)
}

@Injectable()
export default class ShipService {
  constructor (http: Http, token: TokenService) {
    this.http = http
    this.token = token
  }
  getShips () {
    return this.http
      .get(`${config.API_URL}/ships`)
      .map(res => res.json())
      .map(res => {
        return res.map(convertToShip)
      })
  }
  getShip (id) {
    return this.http
      .get(`${config.API_URL}/ships/${id}`)
      .map(res => res.json())
      .map(convertToShip)
  }
  createShip (ship) {
    let opts = this.token.getOptions()
    return this.http
      .post(`${config.API_URL}/ships`, JSON.stringify(ship), opts)
      .map(res => res.json())
  }
  saveShip (ship) {
    let opts = this.token.getOptions()
    return this.http
      .put(`${config.API_URL}/ships/${ship._id}`, JSON.stringify(ship), opts)
      .map(res => res.json())
  }
}
