import {Http} from 'angular2/http'
import {Injectable} from 'angular2/core'
import 'rxjs/add/operator/map'
import config from '../config'
import {Weapon} from './weapon'
import TokenService from '../users/token'

function convertToWeapon (data) {
  return new Weapon(data)
}

@Injectable()
export default class WeaponService {
  constructor (http: Http, token: TokenService) {
    this.http = http
    this.token = token
  }
  getWeapons () {
    return this.http
      .get(`${config.API_URL}/weapons`)
      .map(res => res.json())
      .map(res => {
        return res.map(convertToWeapon)
      })
  }
  getWeapon (id) {
    return this.http
      .get(`${config.API_URL}/weapons/${id}`)
      .map(res => res.json())
      .map(convertToWeapon)
  }
  createWeapon (weapon) {
    let opts = this.token.getOptions()
    return this.http
      .post(`${config.API_URL}/weapons`, JSON.stringify(weapon), opts)
      .map(res => res.json())
  }
  saveWeapon (weapon) {
    let opts = this.token.getOptions()
    return this.http
      .put(`${config.API_URL}/weapons/${weapon._id}`, JSON.stringify(weapon), opts)
      .map(res => res.json())
  }
}
